﻿--
-- Heath SuperChaser
--
-- author Mythos
-- date  22/02/2017
-- www.ARM-team.gr
-- Copyright (C) ARM Team, All Rights Reserved.

Heath = {};
--________________________________________________________________________________________________________________________________________________________
function Heath.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:load(savegame)

	-- Functions
	self.FiHeBa= SpecializationUtil.callSpecializationsFunction("FiHeBa");
	self.FiDi= SpecializationUtil.callSpecializationsFunction("FiDi");
	self.MPCode = SpecializationUtil.callSpecializationsFunction("MPCode");
	
	-- Animations
	self.workmodeEven = getXMLString(self.xmlFile, "vehicle.workmodeEven#animationName");
	self.workmodeOdd = getXMLString(self.xmlFile, "vehicle.workmodeOdd#animationName");
	self.workmodeZero = getXMLString(self.xmlFile, "vehicle.workmodeZero#animationName");
	self.transportmodeEven = getXMLString(self.xmlFile, "vehicle.transportmodeEven#animationName");
	self.transportmodeOdd = getXMLString(self.xmlFile, "vehicle.transportmodeOdd#animationName");
	self.transportmodeFull = getXMLString(self.xmlFile, "vehicle.transportmodeFull#animationName");
	
	self.transportUnloaded = getXMLString(self.xmlFile, "vehicle.transportUnloaded#animationName");
	self.transportUnloadedFull = getXMLString(self.xmlFile, "vehicle.transportUnloadedFull#animationName");
	self.transportUnloadedEven = getXMLString(self.xmlFile, "vehicle.transportUnloadedEven#animationName");
	self.transportSlider = getXMLString(self.xmlFile, "vehicle.transportSlider#animationName");
	
	self.preparefromOdd = getXMLString(self.xmlFile, "vehicle.preparefromOdd#animationName");
	self.preparefromEven = getXMLString(self.xmlFile, "vehicle.preparefromEven#animationName");
	self.preparefromFull = getXMLString(self.xmlFile, "vehicle.preparefromFull#animationName");
	
	self.loadEven2 = getXMLString(self.xmlFile, "vehicle.loadEven2#animationName");
	self.loadEven4 = getXMLString(self.xmlFile, "vehicle.loadEven4#animationName");
	self.loadEven6 = getXMLString(self.xmlFile, "vehicle.loadEven6#animationName");
	self.loadEven8 = getXMLString(self.xmlFile, "vehicle.loadEven8#animationName");
	self.loadOdd = getXMLString(self.xmlFile, "vehicle.loadOdd#animationName");
	self.loadFull = getXMLString(self.xmlFile, "vehicle.loadFull#animationName");
	
	self.load10 = getXMLString(self.xmlFile, "vehicle.load10#animationName");
	self.loadEven = getXMLString(self.xmlFile, "vehicle.loadEven#animationName");
	
	self.unload = getXMLString(self.xmlFile, "vehicle.unload#animationName");
	
	self.slide1 = getXMLString(self.xmlFile, "vehicle.slide1#animationName");
	self.slide2 = getXMLString(self.xmlFile, "vehicle.slide2#animationName");
	self.slide3 = getXMLString(self.xmlFile, "vehicle.slide3#animationName");
	self.slide4 = getXMLString(self.xmlFile, "vehicle.slide4#animationName");
	self.pusherAnim = getXMLString(self.xmlFile, "vehicle.pusher#animationName");

	-- Indexs
	self.base = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.base#index"));
	self.slider = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.slider#index"));
	self.balesJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.balesJoint#index"));
	self.ref = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.baleRef#index"));
	self.baleId2 = nil;
	
	self.spikeJoint = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#joint"));
	self.haySpike = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#hay"));
	self.grassSpike = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#grass"));
	self.strawSpike = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#straw"));
	self.haySpikeEven = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#hayEven"));
	self.grassSpikeEven = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#grassEven"));
	self.strawSpikeEven = Utils.indexToObject(self.components,getXMLString(self.xmlFile,"vehicle.Spikes#strawEven"));
	
	self.hayBaleFilename = getXMLString(self.xmlFile, "vehicle.bales.bale1#filename");
	self.strawBaleFilename = getXMLString(self.xmlFile, "vehicle.bales.bale2#filename");
	self.grassBaleFilename = getXMLString(self.xmlFile, "vehicle.bales.bale3#filename");
	self.tim = 1000;
	
	-- Particles
	self.sParticles = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.sParticles.pSystem(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.. "#index"));
		if node == nil then
			break;
		end;
		local currentPS = {};
		ParticleUtil.loadParticleSystem(self.xmlFile, currentPS, key, node, false, nil, self.baseDirectory);
		table.insert(self.sParticles, currentPS);
		i = i +1;
    end;
	
	self.unParticles = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.unParticles.pSystem(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.. "#index"));
		if node == nil then
			break;
		end;
		local currentPS = {};
        ParticleUtil.loadParticleSystem(self.xmlFile, currentPS, key, node, false, nil, self.baseDirectory);
		table.insert(self.unParticles, currentPS);
		i = i +1;
    end;
	
	-- Bale Types
	self.baleTypes = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.baleTypes.bale(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
			break;
		end;
		local filename = getXMLString(self.xmlFile, key.."#type");
		if filename ~= nil then
			table.insert(self.baleTypes, filename);
		end;
		i = i + 1;
	end;

	-- Bales Loaded Tables
	self.hayBales = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.hayBales.bale(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
		if index ~= nil then
			table.insert(self.hayBales, index);
		end;
		i = i + 1;
	end;
	
	self.grassBales = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.grassBales.bale(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
		if index ~= nil then
			table.insert(self.grassBales, index);
		end;
		i = i + 1;
	end;
		
	self.strawBales = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.strawBales.bale(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components,getXMLString(self.xmlFile, key.."#index"));
		if index ~= nil then
			table.insert(self.strawBales, index);
		end;
		i = i + 1;
	end;
	
	-- Booleans
	self.workMode = false;
	self.prepareMode = false;
	self.unloadMode = false;
	self.unloaded = false;
	
	self.counter = 0;
	self.animEnded = true;
	self.foundIt = false;
	self.baleId = nil;
	self.animName = "nil";
	self.animTime = 0;
	self.fruitBale = "nil";
	
	self.old_dif = 0;
	self.dif = 0;
	
	self.okai = false;
	self.okai2 = false;
	self.okai3 = false;
	
	self.itsOver = false;
	self.itsOver2 = false;
	self.itsOver3 = false;
	self.endGame = false;
	self.ready2go = false;
	self.abort = false;
	self.tranprep = false;
	self.setTim = false;
	self.pusher = false;
	self.state = 0;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:delete()
	for _, particleSystem in pairs(self.sParticles) do
        ParticleUtil.deleteParticleSystem(particleSystem)
	end;
	for _, particleSystem in pairs(self.unParticles) do
        ParticleUtil.deleteParticleSystem(particleSystem)
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:mouseEvent(posX, posY, isDown, isUp, button)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:keyEvent(unicode, sym, modifier, isDown)

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:update(dt)

if self:getIsActiveForInput() and self:getIsActive() then
	if self.animEnded then
		if self.unloadMode then
			if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
				self:MPCode(23, false, 0, 0, 0);
			end;
		elseif self.unloaded then
			if not self.endGame then
				if self.pusher then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
					self.setTim = true;
					self:MPCode(24, false, 0, 0, 0);
					end;
				else
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
						self.abort = true;
						self:MPCode(20, not self.unloaded, 0, 0, 0);
					end;
					
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
						self.setTim = true;
						self:MPCode(24, false, 0, 0, 0);
					end;
					
					if self.counter >8 then
						if InputBinding.hasEvent(InputBinding.PUSHER) then
							self:MPCode(26, false, 0, 0, 0);
						end;
					end;
				end;
			elseif self.ready2go then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
					self:MPCode(20, not self.unloaded, 0, 0, 0);
				end;
			end;
		else
			if self.abort and (self.counter == 10 or self.counter <= 7) then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
					self:MPCode(22, false, 0, 0, 0);
				end;
			elseif self.abort and self.counter ~= 10 and self.counter ~= 7 then
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
					self:MPCode(20, not self.workMode, 0, 0, 0);
				end;
				if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
					self:MPCode(22, false, 0, 0, 0);
				end;
			else
				if not self.workMode and self.counter == 10 then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
						self:MPCode(22, false, 0, 0, 0);
					end;
				else
					if not self.workMode then
						if self.counter == 0 then
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
								self:MPCode(20, not self.workMode, 0, 0, 0);
							end;
						else
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
								self:MPCode(20, not self.workMode, 0, 0, 0);
							end;
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
								self:MPCode(22, false, 0, 0, 0);
							end;
						end;
					else
						if self.counter == 10 then
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
								self:MPCode(20, not self.workMode, 0, 0, 0);
							end;
						else
							if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
								self:MPCode(20, not self.workMode, 0, 0, 0);
							end;
							if self.foundIt then
								if math.mod(self.counter, 2) == 0 then
									if self.fruitBale:lower():find("hay") ~= nil then
										self.fruitBale = "hay";
										self.state = 1;
										self.filename = self.hayBaleFilename;
									elseif
										self.fruitBale:lower():find("grass") ~= nil then
										self.fruitBale = "grass";
										self.state = 9;
										self.filename = self.grassBaleFilename;
									else
										self.fruitBale = "straw";
										self.state = 2;
										self.filename = self.strawBaleFilename;
									end;
								else
									if self.fruitBale:lower():find("hay") ~= nil then
										self.fruitBale = "hay";
										self.state = 3;
										self.filename = self.hayBaleFilename;
									elseif
										self.fruitBale:lower():find("grass") ~= nil then
										self.fruitBale = "grass";
										self.state = 10;
										self.filename = self.grassBaleFilename;
									else
										self.fruitBale = "straw";
										self.state = 4;
										self.filename = self.strawBaleFilename;
									end;
								end;
								self:MPCode(21, false, self.state, 0, 0);
							else
								self:FiHeBa(self.spikeJoint);
							end;
						end;
					end;
				end;
			end;
		end;
	end;
end;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:MPCode(mode, bool, state, dif, olddif, noEventSend)
	MPEvent.sendEvent(self, mode, bool, state, dif, olddif, noEventSend);
	
--______________________________________________________________________________
if mode == 20 then
--______________________________________________________________________________
	if bool then
		if math.mod(self.counter, 2) == 0 then
			if self.counter == 0 then
				self:playAnimation(self.workmodeZero, 1, nil, true);
				self.workMode = true;
				self.abort = false;
			else
				self:playAnimation(self.workmodeOdd, 1, nil, true);
				self.workMode = true;
				self.abort = false;
			end;
		else
			self:playAnimation(self.workmodeEven, 1, nil, true);
			self.workMode = true;
			self.abort = false;
		end;
	else
		if self.unloaded then
			if self.counter == 10 then
				self:playAnimation(self.transportUnloadedFull, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			elseif self.counter == 8 then
				self:playAnimation(self.transportUnloadedEven, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			elseif self.counter == 0 then
				self:playAnimation(self.transportUnloaded, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
			else
				self:playAnimation(self.transportUnloaded, 1, nil, true);
				self.unloaded = false;
				self.ready2go = false;
				self.endGame = false;
				self.okai = false;
				self.tranprep = true;
			end;		
			
		elseif math.mod(self.counter, 2) == 0 then
			if self.counter == 0 then
				self:playAnimation(self.workmodeZero, -1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			elseif self.counter == 10 then
				self:playAnimation(self.transportmodeFull, 1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			else
				self:playAnimation(self.transportmodeEven, 1, nil, true);
				self.workMode = false;
				self.foundIt = false;
			end;
		else
			self:playAnimation(self.transportmodeOdd, 1, nil, true);
			self.workMode = false;
			self.foundIt = false;
		end;
	end;
--______________________________________________________________________________
elseif mode == 21 then	
--______________________________________________________________________________
	if self.counter == 9 then
		local object = g_currentMission:getNodeObject(self.baleId);
		if object ~= nil then
			object:delete();
		end;
		
		
		if state==3 then
			setVisibility(self.haySpikeEven, true);
		elseif state==4 then
			setVisibility(self.strawSpikeEven, true);
		elseif state==10 then
			setVisibility(self.grassSpikeEven, true);
		end;
		
		
		self:playAnimation(self.loadFull, 1, nil, true);
		self.counter = self.counter + 1;
		self.foundIt = false;
	elseif math.mod(self.counter, 2) == 0 then
		local object = g_currentMission:getNodeObject(self.baleId);
		if object ~= nil then
			object:delete();
		end;
		
		
		if state==1 then
			setVisibility(self.haySpike, true);
		elseif state==2 then
			setVisibility(self.strawSpike, true);
		elseif state==9 then
			setVisibility(self.grassSpike, true);
		end;
		
		
		self:playAnimation(self.loadOdd, 1, nil, true);
		self.counter = self.counter + 1;
		self.foundIt = false;
	else
		local object = g_currentMission:getNodeObject(self.baleId);
		if object ~= nil then
			object:delete();
		end;
		
		if state==3 then
			setVisibility(self.haySpikeEven, true);
		elseif state==4 then
			setVisibility(self.strawSpikeEven, true);
		elseif state==10 then
			setVisibility(self.grassSpikeEven, true);
		end;
		
		
		if self.counter ==1 then
			self:playAnimation(self.loadEven2, 1, nil, true);
		elseif self.counter ==3 then
			self:playAnimation(self.loadEven4, 1, nil, true);
		elseif self.counter ==5 then
			self:playAnimation(self.loadEven6, 1, nil, true);
		elseif self.counter ==7 then
			self:playAnimation(self.loadEven8, 1, nil, true);
		end;
		self.counter = self.counter + 1;
		self.foundIt = false;
	end;
--______________________________________________________________________________
elseif mode == 22 then
--______________________________________________________________________________
	if self.counter == 10 then
		self:playAnimation(self.preparefromFull, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
		self.state = 5;
	elseif math.mod(self.counter, 2) == 0 then
		self:playAnimation(self.preparefromEven, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
		self.state = 5;
	else
		self:playAnimation(self.preparefromOdd, 1, nil, true);
		self.unloadMode = true;
		self.abort = false;
		self.state = 5;
	end;
--______________________________________________________________________________
elseif mode == 23 then
--______________________________________________________________________________
	self:playAnimation(self.unload, 1, nil, true);
	self.unloadMode = false;
	self.unloaded = true;
	self.foundIt = false;
--______________________________________________________________________________
elseif mode == 24 then
--______________________________________________________________________________
	for i,v in pairs(self.hayBales) do
		if getVisibility(v) then
			if self.isServer then
				self.filename = self.hayBaleFilename;
				local baleObject = Bale:new(self.isServer, self.isClient);
				local objectFilename = Utils.getFilename(self.filename, self.baseDirectory);
				local x,y,z = getWorldTranslation(v);
				local rx,ry,rz = getWorldRotation(v);
				baleObject:load(objectFilename, x,y,z,rx,ry,rz, 6100);
				baleObject:register();
			end;
		end;
	end;
	
	for i,v in pairs(self.grassBales) do
		if getVisibility(v) then
			if self.isServer then
				self.filename = self.grassBaleFilename;
				local baleObject = Bale:new(self.isServer, self.isClient);
				local objectFilename = Utils.getFilename(self.filename, self.baseDirectory);
				local x,y,z = getWorldTranslation(v);
				local rx,ry,rz = getWorldRotation(v);
				baleObject:load(objectFilename, x,y,z,rx,ry,rz, 6100);
				baleObject:register();
			end;
		end;
	end;
	
	for i,v in pairs(self.strawBales) do
		if getVisibility(v) then
			if self.isServer then
				self.filename = self.strawBaleFilename;
				local baleObject = Bale:new(self.isServer, self.isClient);
				local objectFilename = Utils.getFilename(self.filename, self.baseDirectory);
				local x,y,z = getWorldTranslation(v);
				local rx,ry,rz = getWorldRotation(v);
				baleObject:load(objectFilename, x,y,z,rx,ry,rz, 6100);
				baleObject:register();
			end;
		end;
	end;

	for i,v in pairs(self.hayBales) do
		setVisibility(v, false);
	end;
	
	for i,v in pairs(self.strawBales) do
		setVisibility(v, false);
	end;
	
	for i,v in pairs(self.grassBales) do
		setVisibility(v, false);
	end;
	
	self.counter = 0;
	
	local limit = 1;
	for index, item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then
			local refx, refy, refz = getWorldTranslation(self.ref);
			local bx, by, bz = getWorldTranslation(item.item.nodeId);
			self.distance = Utils.vector3Length(refx-bx, refy-by, refz-bz);
			if self.distance < limit then
				self.baleId2 = item.item.nodeId;
				break;
			end;
		else
			self.baleId2 = nil;
		end;
	end;
	
	setTranslation(self.balesJoint, 0, 0, 6.661);
	
	if self.pusher then
		translate(self.strawBales[9], 0, -0.276, 0);
		translate(self.strawBales[10], 0, -0.276, 0);
		translate(self.hayBales[9], 0, -0.276, 0);
		translate(self.hayBales[10], 0, -0.276, 0);
		translate(self.grassBales[9], 0, -0.276, 0);
		translate(self.grassBales[10], 0, -0.276, 0);
		self:playAnimation(self.pusherAnim, -1, nil, true);
		self.pusher = false;
	end;
	
	self.endGame = true;
	if self.tranprep then
		self.tranprep = false;
	end;
	for _, ps in pairs(self.unParticles) do
		ParticleUtil.setEmittingState(ps, true);
	end;
--______________________________________________________________________________
elseif mode == 25 then
--______________________________________________________________________________
	if state==1 then
		setVisibility(self.haySpike, false);
		local i = self.counter;
		setVisibility(self.hayBales[i], true);
	elseif state==2 then
		setVisibility(self.strawSpike, false);
		local i = self.counter;
		setVisibility(self.strawBales[i], true);
	elseif state==3 then
		setVisibility(self.haySpikeEven, false);
		local i = self.counter;
		setVisibility(self.hayBales[i], true);
	elseif state==4 then
		setVisibility(self.strawSpikeEven, false);
		local i = self.counter;
		setVisibility(self.strawBales[i], true);
	elseif state==10 then
		setVisibility(self.grassSpikeEven, false);
		local i = self.counter;
		setVisibility(self.grassBales[i], true);
	elseif state==9 then
		setVisibility(self.grassSpike, false);
		local i = self.counter;
		setVisibility(self.grassBales[i], true);
	end;
	self.itsOver = true;
--______________________________________________________________________________
elseif mode == 26 then
--______________________________________________________________________________
	self.pusher = true;
	self:playAnimation(self.pusherAnim, 1, nil, true);
--______________________________________________________________________________
elseif state==5 then
	if self.counter ==1 then
		self:playAnimation(self.slide1, 1, nil, true);
	elseif self.counter ==2 or self.counter ==3 then
		self:playAnimation(self.slide2, 1, nil, true);
	elseif self.counter ==4 or self.counter ==5 then
		self:playAnimation(self.slide3, 1, nil, true);
	elseif self.counter ==6 or self.counter ==7 then
		self:playAnimation(self.slide4, 1, nil, true);
	end;
elseif state==6 then
	self.setTim = false;
	for _, ps in pairs(self.unParticles) do
		ParticleUtil.setEmittingState(ps, false);
	end;
	self.tim = 1000;
elseif state==7 then
	self:playAnimation(self.transportSlider, 1, nil, true);
	self.old_dif = 0;
	self.ready2go = true;
elseif state==8 then
	translate(self.slider, 0, 0, -(dif-olddif));
	self.old_dif = dif;
end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:updateTick(dt)
	if self:getIsActive() then

		if self.endGame and not self.okai and self.baleId2 ~= nil then
			local refx, refy, refz = getWorldTranslation(self.ref);
			local bx, by, bz = getWorldTranslation(self.baleId2);
			if bx ~= nil then
				self.sdiff = Utils.vector3Length(refx-bx, refy-by, refz-bz);
				self.sliderConfffz = refz-bz;
				self.sliderConfffx = refx-bx;
				self.okai = true;
			else
				self.okai = true;
			end;
		elseif self.endGame and not self.okai and self.baleId2 == nil then
			self.okai = true;
		end;
		
		if self.endGame and not self.ready2go and self.baleId2~= nil then
			local refx, refy, refz = getWorldTranslation(self.ref);
			local bx, by, bz = getWorldTranslation(self.baleId2);
			if bx ~= nil then
				local diff = Utils.vector3Length(refx-bx, refy-by, refz-bz);
				
				local sliderConfz = refz-bz;
				local sliderConfx = refx-bx;
				
				self.dif = diff - self.sdiff;
				if self.dif > 2 then
					self.state = 7;
					self:MPCode(0, false, self.state, 0, 0);
				elseif self.dif < 1.3 then
					if self.sliderConfffz ~= 0 then
						if self.sliderConfffz > 0 then
							if sliderConfz > self.sliderConfffz then
								if self.dif ~= self.old_dif then
									self.state = 8;
									self:MPCode(0, false, self.state, self.dif, self.old_dif);
								end;
							end;
						else
							if sliderConfz < self.sliderConfffz then
								if self.dif ~= self.old_dif then
									self.state = 8;
									self:MPCode(0, false, self.state, self.dif, self.old_dif);
								end;
							end;
						end;
					else
						if self.sliderConfffx > 0 then
							if sliderConfx > self.sliderConfffx then
								if self.dif ~= self.old_dif then
									self.state = 8;
									self:MPCode(0, false, self.state, self.dif, self.old_dif);
								end;
							end;
						else
							if sliderConfx < self.sliderConfffx then
								if self.dif ~= self.old_dif then
									self.state = 8;
									self:MPCode(0, false, self.state, self.dif, self.old_dif);
								end;
							end;
						end;
					end;
				end;
			else
				self.state = 7;
				self:MPCode(0, false, self.state, 0, 0);
			end;
		elseif self.endGame and not self.ready2go and self.baleId2 == nil then
			self.old_dif = 0;
			self.ready2go = true;
		end;
		
		for name,v in pairs(self.animations) do
			if self.activeAnimations[name] ~= nil then
				self.animEnded = false;
				self.animName = name;
				break;
			else
				self.animEnded = true;
				self.animName = "nil";
				self.itsOver = false;
				self.itsOver2 = false;
				self.itsOver3 = false;
			end;
		end;
		
		if self.setTim then
			self.tim = self.tim - dt;
			if self.tim <0 then
				self.state = 6;
				self:MPCode(0, false, self.state, 0, 0);
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "WorkModeOdd" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2500 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "WorkModeOdd" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 3100 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "WorkModeEven" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2500 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "WorkModeEven" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 3100 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;

		if not self.tranprep then
			if self.animName ~= "nil" and self.animName == "PrepareModeEven" and not self.okai2 then
				self.animTime = self:getRealAnimationTime(self.animName);
				if self.animTime > 0 then
					for _, ps in pairs(self.sParticles) do
						ParticleUtil.setEmittingState(ps, true);
					end;
					self.okai2 = true;
				end;
			end;
			
			if self.animName ~= "nil" and self.animName == "PrepareModeEven" and self.okai2 then
				self.animTime = self:getRealAnimationTime(self.animName);
				if self.animTime > 600 then
					for _, ps in pairs(self.sParticles) do
						ParticleUtil.setEmittingState(ps, false);
					end;
					self.okai2 = false;
				end;
			end;
		end;
		
		if self.tranprep == false or (self.tranprep and self.counter == 9) then
			if self.animName ~= "nil" and self.animName == "PrepareModeOdd" and not self.okai2 then
				self.animTime = self:getRealAnimationTime(self.animName);
				if self.animTime > 0 then
					for _, ps in pairs(self.sParticles) do
						ParticleUtil.setEmittingState(ps, true);
					end;
					self.okai2 = true;
				end;
			end;
				
			if self.animName ~= "nil" and self.animName == "PrepareModeOdd" and self.okai2 then
				self.animTime = self:getRealAnimationTime(self.animName);
				if self.animTime > 600 then
					for _, ps in pairs(self.sParticles) do
						ParticleUtil.setEmittingState(ps, false);
					end;
					self.okai2 = false;
				end;
			end;		
		end;
		
		if self.animName ~= "nil" and self.animName == "PrepareModeFull" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "PrepareModeFull" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 600 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;

		if self.animName ~= "nil" and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 3000 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;
		
		if self.animName ~= "nil" and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 6000 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and (self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8) and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 6600 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeOdd" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeOdd" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2000 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeOdd" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2500 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeOdd" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 3100 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeFull" and not self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 0 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, true);
				end;
				self.okai2 = true;
			end;
		end;
		
		if self.animName ~= "nil" and self.animName == "LoadModeFull" and self.okai2 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2900 then
				for _, ps in pairs(self.sParticles) do
					ParticleUtil.setEmittingState(ps, false);
				end;
				self.okai2 = false;
			end;
		end;

		if self.animName == self.loadOdd and not self.itsOver then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2000 then
				self:MPCode(25, false, self.state, 0, 0);
			end;
		end;
			
		if self.animName == self.loadFull and not self.itsOver then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 2900 then
				self:MPCode(25, false, self.state, 0, 0);
			end;
		end;
			
		if self.animName == self.loadEven2 or self.animName == self.loadEven4 or self.animName == self.loadEven6 or self.animName == self.loadEven8 then
			self.animTime = self:getRealAnimationTime(self.animName);
			if self.animTime > 3000 and not self.itsOver then
				self:MPCode(25, false, self.state, 0, 0);
			end;
		end;
			
		if not self.itsOver3 and (self.animName == self.preparefromFull or self.animName == self.preparefromEven or self.animName == self.preparefromOdd) then
			self.animTime = self:getAnimationTime(self.animName);
			if self.animTime >0.8 then
				self:MPCode(0, false, self.state, 0, 0);
			end;
		end;
		
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:draw()

if self.animEnded then
	if self.unloadMode then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOADMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
	elseif self.unloaded then
		if not self.endGame then
			if self.pusher then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("ABORT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UNLOAD"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
				if self.counter >8 then
					g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PUSHER"), self.typeDesc), InputBinding.PUSHER);
				end;
			end;
		elseif self.ready2go then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LOWER_PLATFORM"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
		end;
	else
		if self.abort and (self.counter == 10 or self.counter <= 7) then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);	
		elseif self.abort and self.counter ~= 10 and self.counter ~= 7 then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
		else
			if self.counter == 10 and not self.workMode then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
			else
				if not self.workMode then
					if self.counter == 0 then
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
					else
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WORKMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("PREPAREMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA3);
					end;
				else
					if	self.counter == 10 then
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
					else
						g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TRANSPORTMODE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
					end;
				end;
			end;
		end;
	end;
end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiDi(node,noEventSend)
	local x,y,z = localDirectionToWorld(node, 0, 0, 1);
	local length = Utils.vector2Length(x,z);
	local dX = x/length;
	local dZ = z/length;
	local JointDir = math.deg(math.atan2(dX,dZ)); 
	if JointDir < 0 then
		JointDir = 360 - (JointDir * -1);
	end;
	self.objDir = JointDir;

end;

--________________________________________________________________________________________________________________________________________________________
function Heath:FiHeBa(LoadJoint,noEventSend)
	
	local px, py, pz = getWorldTranslation(LoadJoint);
	local nearestDistance = 1;
	local nearestBale = nil;
	
	for index, item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then
			for i, baleType in pairs(self.baleTypes) do
				if getName(item.item.nodeId) == baleType then
					local bx, by, bz = getWorldTranslation(item.item.nodeId);
					local distance = Utils.vector3Length(px-bx, py-by, pz-bz);
					if distance < nearestDistance then
						self.baleId = item.item.nodeId;
						self:FiDi(self.baleId);
						self.baleDir = self.objDir;
						self:FiDi(LoadJoint);
						self.spikeDir = self.objDir;
						local realD = self.spikeDir - self.baleDir;
						if math.abs(realD) <=45 or (180-math.abs(realD)) <=45 then
							self.foundIt = true;
							self.baleId = item.item.nodeId;
							self.fruitBale = baleType;
						else
							self.foundIt = false;
							self.baleId = nil;
							self.fruitBale = "nil";
						end;
					end;
					break;
				end;
			end;
			if self.foundIt then
				break;
			end;
		end;
	end;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:postLoad(savegame)
	if savegame ~= nil and not savegame.resetVehicles then
		self.counter = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."#numBales"),0);
		if self.counter==2 or self.counter==3 then
			setTranslation(self.balesJoint, 0, 0, 5.461);
		elseif self.counter==4 or self.counter==5 then
			setTranslation(self.balesJoint, 0, 0, 4.261);
		elseif self.counter==6 or self.counter==7 then
			setTranslation(self.balesJoint, 0, 0, 3.061);
		elseif self.counter==8 or self.counter==9 or self.counter==10 then
			setTranslation(self.balesJoint, 0, 0, 1.861);
		end;
		
		if math.mod(self.counter, 2) == 0 and self.counter ~= 10 and self.counter ~= 0 then
			self:playAnimation(self.loadEven, 20, nil, true);
		elseif self.counter == 10 then
			self:playAnimation(self.load10, 20, nil, true);
		end;

		for i=1, 10 do
			local baleKey = savegame.key..string.format(".Bale(%d)", i-1);
			
			local vState = getXMLBool(savegame.xmlFile, baleKey.."#vState");
			setVisibility(self.hayBales[i], vState);
		end;
		
		for i=11, 20 do
			local baleKey = savegame.key..string.format(".Bale(%d)", i-1);
			
			local vState = getXMLBool(savegame.xmlFile, baleKey.."#vState");
			setVisibility(self.strawBales[i-10], vState);
		end;
		
		for i=21, 30 do
			local baleKey = savegame.key..string.format(".Bale(%d)", i-1);
			
			local vState = getXMLBool(savegame.xmlFile, baleKey.."#vState");
			setVisibility(self.grassBales[i-20], vState);
		end;
		
	end;
	
	return BaseMission.VEHICLE_LOAD_OK;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:getSaveAttributesAndNodes(nodeIdent)

	local attributes = 'numBales="'..tostring(self.counter)..'"';
	
	local nodes = "";
	local baleCounter = 0;
	
	for i=1, 10 do
		local vState = getVisibility(self.hayBales[i]);
		if baleCounter>0 then
			nodes = nodes.."\n";
		end;
		if vState then
			nodes = nodes..nodeIdent..'<Bale vState="true" />';
		else
			nodes = nodes..nodeIdent..'<Bale vState="false" />';
		end;
		baleCounter = baleCounter +1;
	end;
	
	for i=1, 10 do
		local vState = getVisibility(self.strawBales[i]);
		if baleCounter>0 then
			nodes = nodes.."\n";
		end;
		if vState then
			nodes = nodes..nodeIdent..'<Bale vState="true" />';
		else
			nodes = nodes..nodeIdent..'<Bale vState="false" />';
		end;
		baleCounter = baleCounter +1;
	end;
	
	for i=1, 10 do
		local vState = getVisibility(self.grassBales[i]);
		if baleCounter>0 then
			nodes = nodes.."\n";
		end;
		if vState then
			nodes = nodes..nodeIdent..'<Bale vState="true" />';
		else
			nodes = nodes..nodeIdent..'<Bale vState="false" />';
		end;
		baleCounter = baleCounter +1;
	end;
	
	return attributes,nodes;
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:readStream(streamId, connection)

	self.animEnded = streamReadBool(streamId);
	self.unloadMode = streamReadBool(streamId);
	self.unloaded = streamReadBool(streamId);
	self.abort = streamReadBool(streamId);
	self.workMode = streamReadBool(streamId);
	self.endGame = streamReadBool(streamId);
	self.ready2go = streamReadBool(streamId);
	self.prepareMode = streamReadBool(streamId);
	
	self.okai = streamReadBool(streamId);
	self.okai2 = streamReadBool(streamId);
	self.okai3 = streamReadBool(streamId);
	
	self.itsOver = streamReadBool(streamId);
	self.itsOver2 = streamReadBool(streamId);
	self.itsOver3 = streamReadBool(streamId);
	self.tranprep = streamReadBool(streamId);
	self.pusher =  streamReadBool(streamId);
	self.counter = streamReadInt32(streamId);
	
	self.animName = streamReadString(streamId);
	self.animTime = streamReadFloat32(streamId);
	self.fruitBale = streamReadString(streamId);
	
	for i=1, 10 do
		local vhState = streamReadBool(streamId);
		setVisibility(self.hayBales[i], vhState);
	end;
	
	for i=1, 10 do
		local vhState = streamReadBool(streamId);
		setVisibility(self.grassBales[i], vhState);
	end;
	
	for i=1, 10 do
		local vsState = streamReadBool(streamId);
		setVisibility(self.strawBales[i], vsState);
	end;
	
	if self.counter==2 or self.counter==3 then
		setTranslation(self.balesJoint, 0, 0, 5.461);
	elseif self.counter==4 or self.counter==5 then
		setTranslation(self.balesJoint, 0, 0, 4.261);
	elseif self.counter==6 or self.counter==7 then
		setTranslation(self.balesJoint, 0, 0, 3.061);
	elseif self.counter==8 or self.counter==9 or self.counter==10 then
		setTranslation(self.balesJoint, 0, 0, 1.861);
	end;
	
	self:MPCode(20, self.workMode, 0, 0, 0, true);
	
	if math.mod(self.counter, 2) == 0 and self.counter ~= 10 and self.counter ~= 0 then
		self:playAnimation(self.loadEven, 1, nil, true);
		AnimatedVehicle.updateAnimations(self, 99999999);
	elseif self.counter == 10 then
		self:playAnimation(self.load10, 1, nil, true);
		AnimatedVehicle.updateAnimations(self, 99999999);
	end;

	for name,v in pairs(self.animations) do
		if self.activeAnimations[name] ~= nil then
			self:playAnimation(name, 1, nil, true);
			AnimatedVehicle.updateAnimations(self, 99999999);
		end;
	end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Heath:writeStream(streamId, connection)
	
	streamWriteBool(streamId, self.animEnded);
    streamWriteBool(streamId, self.unloadMode);
	streamWriteBool(streamId, self.unloaded);
	streamWriteBool(streamId, self.abort);
	streamWriteBool(streamId, self.workMode);
	streamWriteBool(streamId, self.endGame);
	streamWriteBool(streamId, self.ready2go);
	streamWriteBool(streamId, self.prepareMode);

	streamWriteBool(streamId, self.okai);
	streamWriteBool(streamId, self.okai2);
	streamWriteBool(streamId, self.okai3);
	
	streamWriteBool(streamId, self.itsOver);
	streamWriteBool(streamId, self.itsOver2);
	streamWriteBool(streamId, self.itsOver3);
	streamWriteBool(streamId, self.tranprep);
	streamWriteBool(streamId, self.pusher);
	streamWriteInt32(streamId, self.counter);
	
	streamWriteString(streamId, self.animName);
	streamWriteFloat32(streamId, self.animTime);
	streamWriteString(streamId, self.fruitBale);

	for i=1, 10 do
		local vhState = getVisibility(self.hayBales[i]);
		streamWriteBool(streamId, vhState);
	end;
	
	for i=1, 10 do
		local vhState = getVisibility(self.grassBales[i]);
		streamWriteBool(streamId, vhState);
	end;
	
	for i=1, 10 do
		local vsState = getVisibility(self.strawBales[i]);
		streamWriteBool(streamId, vsState);
	end;
	
end;

--**********************************************************************************************************************************************************************************
MPEvent = {};
MPEvent_mt = Class(MPEvent, Event);

InitEventClass(MPEvent, "MPEvent");

function MPEvent:emptyNew()
    local self = Event:new(MPEvent_mt);
    self.className="MPEvent";
    return self;
end;

function MPEvent:new(vehicle, mode, bool, state, dif, olddif)
    local self = MPEvent:emptyNew()
    self.vehicle = vehicle;
	self.mode = mode;
	self.bool = bool;
	self.state = state;
	self.dif = dif;
	self.old_dif = olddif;
    return self;
end;

function MPEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.mode = streamReadInt32(streamId);
	self.bool = streamReadBool(streamId);
	self.state = streamReadInt32(streamId);
    self.dif = streamReadFloat32(streamId);
	self.old_dif = streamReadFloat32(streamId);
	self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function MPEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, self.mode);
	streamWriteBool(streamId, self.bool);
	streamWriteInt32(streamId, self.state);
	streamWriteFloat32(streamId, self.dif);
	streamWriteFloat32(streamId, self.old_dif);
end;

function MPEvent:run(connection)   
	self.vehicle:MPCode(self.mode, self.bool, self.state, self.dif, self.old_dif, true);
	if not connection:getIsServer() then
        g_server:broadcastEvent(MPEvent:new(self.vehicle, self.mode, self.bool, self.state, self.dif, self.old_dif), nil, connection, self.vehicle);
    end;
end;

function MPEvent.sendEvent(vehicle, mode, bool, state, dif, olddif, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MPEvent:new(vehicle, mode, bool, state, dif, olddif), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MPEvent:new(vehicle, mode, bool, state, dif, olddif));
		end;
	end;
end;